section .rodata
    prompt1  db "Enter a number:",0
    prompt2  db "The number of bits that are on in %d are %d.",10,0
    num_format db "%d"

section .text
    global main
    extern printf, scanf

    main:
        push  rsp
        mov   rbp, rsp
        sub   rsp, 8    ; we plan to read in a 4-byte integer on the stack
        push  rbx
        push  r12
        push  r13
        push  r14
        push  r15
        pushfq 
       
        ; read in the 4-byte integer
        mov   rdi, dword prompt1
        xor   rax, rax
        call  printf
        lea   rsi, [rbp-8]
        mov   rdi, dword num_format       
        xor   rax, rax
        call  scanf

        ; count the bits that have value 1
        mov   eax, [rbp-8]    ; since we deal with a 4-byte integer we use EAX here. 
                              ; If we want to work with a 64-bit integer we will use RAX instead.
        mov   rcx, 64         ; set the maximum number of bits you want to count, in this case 64 (register size).
        xor   rdx, rdx
  count_loop:
        rol   rax, 1          ; since we want to rotate the bits so as to maintain the unshifted value we use RAX.
        adc   rdx, 0          ; since the most-significant bit is moved into CF, we add with carry. 
        loop  count_loop

        ; print the result
                          ; the third argument is the counted value, but that is already stored in RDX.
        mov   rsi, rax    ; move the original 4-byte integer value into RSI. We can also use EAX and ESI. 
        mov   rdi, dword prompt2
        xor   rax, rax
        call  printf

        pop   rcx         ; removing the subtracted 8 bytes
        popfq   
        pop   r15
        pop   r14
        pop   r13
        pop   r12
        pop   rbx
        leave
        ret
